var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default,
  devtoolsPlugin: () => devtoolsPlugin
});
module.exports = __toCommonJS(src_exports);
var import_core = require("@babel/core");
var t = __toESM(require("@babel/types"));

// src/utils.ts
var LOWERCASE_REGEX = /^[a-z0-9]+$/;
var isLowercase = (s) => LOWERCASE_REGEX.test(s);
var getLocationAttribute = (filePath, line, column) => filePath + ":" + line + ":" + column;
function getFileExtension(filename) {
  const index = filename.lastIndexOf(".");
  return index < 0 ? "" : filename.substring(index);
}
function isFileJSX(filename) {
  const ext = getFileExtension(filename);
  return ext === ".jsx" || ext === ".tsx";
}

// ../shared/variables.ts
var LOCATION_ATTRIBUTE_NAME = "data-source-loc";

// src/index.ts
var src_default = () => ({
  name: "@solid-devtools/babel-plugin",
  visitor: {
    JSXOpeningElement: (path, state) => {
      const container = path.container;
      if (container.openingElement.name.type !== "JSXIdentifier")
        return;
      const name = container.openingElement.name.name;
      if (!isLowercase(name))
        return;
      const location = container.openingElement.loc;
      if (!location)
        return;
      const { filename } = state;
      if (typeof filename !== "string")
        return;
      container.openingElement.attributes.push(t.jsxAttribute(t.jsxIdentifier(LOCATION_ATTRIBUTE_NAME), t.stringLiteral(getLocationAttribute(filename, location.start.line, location.start.column))));
    }
  }
});
var devtoolsPlugin = () => {
  let enablePlugin = false;
  let projectRoot = process.cwd();
  return {
    name: "solid-devtools",
    enforce: "pre",
    configResolved(config) {
      enablePlugin = config.command === "serve" && config.mode !== "production";
    },
    async transform(source, id, transformOptions) {
      if ((transformOptions == null ? void 0 : transformOptions.ssr) || !enablePlugin || !isFileJSX(id))
        return;
      const result = await (0, import_core.transformAsync)(source, {
        babelrc: false,
        configFile: false,
        root: projectRoot,
        filename: id,
        sourceFileName: id,
        plugins: [
          ["@babel/plugin-syntax-typescript", { isTSX: true }],
          "@solid-devtools/babel-plugin"
        ]
      });
      if (!result)
        return null;
      const { code } = result;
      if (!code)
        return null;
      return { code };
    }
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  devtoolsPlugin
});
